package br.org.scadabr.vo.permission;

import java.util.Map;

import com.serotonin.json.JsonException;
import com.serotonin.json.JsonObject;
import com.serotonin.json.JsonReader;
import com.serotonin.json.JsonRemoteEntity;
import com.serotonin.json.JsonSerializable;
import com.serotonin.mango.view.ShareUser;
import com.serotonin.mango.vo.WatchList;
import org.scada_lts.mango.service.WatchListService;

@JsonRemoteEntity
public class WatchListAccess extends Permission implements JsonSerializable {

	public WatchListAccess() {
		super();
	}

	public WatchListAccess(int id, int permission) {
		super(id, permission);
	}

	public static WatchListAccess none(int watchListId) {
		return new WatchListAccess(watchListId, ShareUser.ACCESS_NONE);
	}

	@Override
	public void jsonSerialize(Map<String, Object> map) {
		WatchList watchList = new WatchListService().getWatchList(id);
		if(watchList != null) {
			map.put("watchlistXid", watchList.getXid());
		} else {
			throw new NullPointerException("watchlistXid is null!");
		}
		map.put("permission", ACCESS_CODES.getCode(permission));
	}

	@Override
	public void jsonDeserialize(JsonReader reader, JsonObject json)
			throws JsonException {
		WatchListService watchListService = new WatchListService();
		DeserializePermissionUtils
				.updatePermission(this, watchListService::getWatchList, WatchList::getId,
						json, "watchlistXid", "watchlist: {0}");
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (!(o instanceof WatchListAccess)) return false;
		return super.equals(o);
	}

	@Override
	public int hashCode() {
		return super.hashCode();
	}

	@Override
	public String toString() {
		return "WatchListAccess{" +
				"id=" + id +
				", permission=" + permission +
				'}';
	}
}
