package br.org.scadabr.dnp34j.samples;

import java.util.Calendar;
import java.util.List;

import br.org.scadabr.dnp34j.master.session.DNPUser;
import br.org.scadabr.dnp34j.master.session.config.DNPConfig;
import br.org.scadabr.dnp34j.master.session.config.EthernetParameters;
import br.org.scadabr.dnp34j.master.session.database.DataElement;

public class SampleEthernet {
	private static DNPUser user;

	/**
	 * @param args
	 * @throws Exception
	 * @throws Exception
	 */

	public static void main(String[] args) throws Exception {
		DNPConfig config = new DNPConfig(new EthernetParameters("127.0.0.1",
				20000), 1, 2);
		user = new DNPUser(config);

		user.init();
		// 69775326259457
		Thread.sleep(1000);

		user.sendSynch(user.buildSetTimeAndDateMsg());
		for (int i = 0; i < 50000; i++) {
			try {
				if (i % 20 == 0) {
					System.out.println("STATIC");
					user.sendSynch(user.buildReadStaticDataMsg());
				} else {
					System.out.println("RBE");
					user.sendSynch(user.buildReadEventDataMsg());
				}

			} catch (Exception e) {
				e.printStackTrace();
			}

			// System.out.println("Binary Points: "
			// + user.getDatabase().getBinaryInputPoints().size());
			Thread.sleep(300);
			List<DataElement> binHist = user.getDatabase()
					.readBinaryInputPoint(0);

			for (DataElement dataElement : binHist) {

				Calendar calendar = Calendar.getInstance();
				calendar.setTimeInMillis(dataElement.getTimestamp()
						- calendar.getTimeZone().getRawOffset());
				System.out.println("Bin 0 changed to " + dataElement.getValue()
						+ " at " + calendar.getTime());
			}
			Thread.sleep(1000);
		}
		user.stop();
		System.exit(0);
	}
}
