package br.org.scadabr.dnp34j.samples;

import br.org.scadabr.dnp34j.master.session.DNPUser;
import br.org.scadabr.dnp34j.master.session.config.DNPConfig;
import br.org.scadabr.dnp34j.master.session.config.EthernetParameters;
import br.org.scadabr.dnp34j.master.session.config.SerialParameters;
import br.org.scadabr.dnp34j.master.session.database.DataElement;

public class ScadaBRInterface {
	private DNPUser user;
	private DNPConfig configuration;
	private int staticPollFrequence = 30;

	public void initEthernet(EthernetParameters parameters, int masterAddress,
			int slaveAddress, int staticPollFrequence) throws Exception {
		configuration = new DNPConfig(parameters, masterAddress, slaveAddress);
		this.staticPollFrequence = staticPollFrequence;
		init(configuration);
	}

	public void initSerial(SerialParameters parameters, int masterAddress,
			int slaveAddress, int staticPollFrequence) throws Exception {
		configuration = new DNPConfig(parameters, masterAddress, slaveAddress);
		this.staticPollFrequence = staticPollFrequence;
		init(configuration);
	}

	private void init(DNPConfig configuration) throws Exception {
		user = new DNPUser(configuration);

		user.init();
	}

	private int pollCount = 0;

	public void doPoll() throws Exception {
		if (pollCount == 0) {
			doStaticPoll();
			pollCount++;
		} else {
			doRBEPoll();
			pollCount++;
			if (pollCount > staticPollFrequence)
				pollCount = 0;
		}
		Thread.sleep(100);
	}

	private void doStaticPoll() throws Exception {
		user.sendSynch(user.buildReadStaticDataMsg());
	}

	private void doRBEPoll() throws Exception {
		user.sendSynch(user.buildReadEventDataMsg());
	}

	public void terminate() throws Exception {
		user.stop();
	}

	public DataElement getElement(byte group, int index) throws Exception {
		return null;
		// return user.getDatabase().readLastRecord(group, index);
	}
}
