package br.org.scadabr.luciol.database;

import br.org.scadabr.luciol.ihm.Labels;
import br.org.scadabr.protocol.lib.xml.XMLInterface;
import br.org.scadabr.protocol.lib.xml.KXMLElement;

/**
 * Class for Analog Output data elements.
 *
 * @author <a href="mailto:alexis.bietti@sysaware.com">Alexis BIETTI</a>
 */
public class AnalogOutput extends AnalogElement implements XMLInterface,
  Command {
  //---------------------------------------------------------------------------
  // Attributes
  //---------------------------------------------------------------------------

  /** ID of the {@link br.org.scadabr.luciol.database.SelectBeforeOperate} */
  public int selectBeforeOperateID = -1;

  //---------------------------------------------------------------------------
  // Constructor
  //---------------------------------------------------------------------------
  public AnalogOutput() {
    super();
  }

  //---------------------------------------------------------------------------
  // Methods
  //---------------------------------------------------------------------------
  public String getName() {
    return Labels.ANALOG_OUTPUT;
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public int getSelectBeforeOperateID() {
    return selectBeforeOperateID;
  }

  /**
   * DOCUMENT ME!
   *
   * @return DOCUMENT ME!
   */
  public String servlet() {
    return "anaout";
  }

  //---------------------------------------------------------------------------
  // Interface XMLInterface
  //---------------------------------------------------------------------------

  /**
   * See the general contract of this method in the interface {@link
   * br.org.scadabr.io.XMLInterface}
   */
  public void inputFromXML(KXMLElement xml) throws IllegalArgumentException {
    super.inputFromXML(xml);
  }

  /**
   * See the general contract of this method in the interface {@link
   * br.org.scadabr.io.XMLInterface}
   */
  public KXMLElement outputToXML() {
    KXMLElement root = super.outputToXML();
    root.setTagName(XML_ANALOG_OUTPUT);

    if (selectBeforeOperateID > -1) {
      root.addProperty(XML_SBOID, this.selectBeforeOperateID);
    }

    return root;
  }
}


// End AnalogOutput.java
