//
// Database for Luciol. BLOB element class
// 
// Class     br.org.scadabr.luciol.database.BLOBElement
// File      BLOBElement.java
// Author    Alexis BIETTI <alexis.bietti@sysaware.com> 
// (c)       SysAware <http://www.sysaware.com/>
//
package br.org.scadabr.luciol.database;

import java.io.IOException;
import java.io.InputStream;

/**
 * A Binary Large Object (BLOB) is a large piece of arbitrary data.
 * 
 * @author <a href="mailto:alexis.bietti@sysaware.com">Alexis BIETTI</a>
 * @version 1.0 - 14 avr. 03
 */
public class BLOBElement extends DataElement {

  //---------------------------------------------------------------------------
  // Constructors
  //---------------------------------------------------------------------------

  /**
   * @see br.org.scadabr.luciol.database.DataElement#DataElement()
   */
  BLOBElement() {
    super();
  }

  /**
   * @see br.org.scadabr.luciol.database.DataElement#DataElement(int)
   */
  BLOBElement(int historySize) {
    super(historySize);
  }

  //---------------------------------------------------------------------------
  // Methods
  //---------------------------------------------------------------------------

  /**
   * Open an InputStream that reads the BLOB object associated with this
   * element.
   */
  public InputStream openInputStream() throws IOException {
    return null;
  }

  //---------------------------------------------------------------------------
  // Methods inherited from class DataElement
  //---------------------------------------------------------------------------

  public String getName() {
    return "BLOBElement";
  }

  public Object defaultValue() {
    return null;
  }

  public Record instanciateRecord() {
    return null;
  }

  public String servlet() {
    return null;
  }

  public int getDefaultLogSize() {
    return 0;
  }

}
