/*
 * Bricks are aggregation of several data elements that have a functional
 * purpose.
 *
 * Class      br.org.scadabr.luciol.database.Brick
 * File       Brick.java
 * Author     Alexis BIETTI <alexis.bietti@sysaware.com>
 * (c)        SysAware <http://www.sysaware.com>
 */

//-----------------------------------------------------------------------------
// Imports
//-----------------------------------------------------------------------------
package br.org.scadabr.luciol.database;

import br.org.scadabr.protocol.lib.xml.XMLInterface;

//-----------------------------------------------------------------------------
// Class
//-----------------------------------------------------------------------------

/**
 * <p>
 * Bricks are aggregations of several data elements. Bricks have a functional
 * purpose in a logical device.
 * </p>
 *
 * @author <a href="mailto:alexis.bietti@sysaware.com">Alexis BIETTI</a>
 */
public interface Brick extends XMLInterface {
  //---------------------------------------------------------------------------
  // Constants
  //---------------------------------------------------------------------------

  /*
 * Read / write flags
 */
  public static final byte READ       = 1;
  public static final byte WRITE      = 2;
  public static final byte READ_WRITE = READ | WRITE;

  //---------------------------------------------------------------------------
  // Methods
  //---------------------------------------------------------------------------

  /**
   * Return a textual name for this brick.
   */
  public String getName();
}


// End Brick.java
