package br.org.scadabr.luciol.ihm;

import br.org.scadabr.luciol.database.AnalogInput;
import br.org.scadabr.luciol.database.DataElement;
import br.org.scadabr.luciol.database.DigitalInput;
import br.org.scadabr.luciol.database.DigitalOutput;

/**
 * This class is the entry point of human-language labels in the configurator
 * interface.
 * 
 * <p>
 * To change the language, just change the "extends" part of this class to point
 * to the wanted language package.
 * </p>
 * 
 * @author <a href="mailto:alexis.bietti@sysaware.com"> Alexis BIETTI </a>
 * @version 1.0
 */
public class Labels extends br.org.scadabr.luciol.ihm.english.Labels {

	public static String ioName(DataElement elem) {
		if (elem instanceof DigitalInput) {
			return DIGITAL_INPUT;
		} else if (elem instanceof DigitalOutput) {
			return DIGITAL_OUTPUT;
		} else if (elem instanceof AnalogInput) {
			return ANALOG_INPUT;
		} else {
			return UNKNOWN_TYPE;
		}
	}
}