package br.org.scadabr.luciol.ihm.english;


/**
 * <p>English version of true language labels for the HMI.
 *
 * @author <a href="mailto:alexis.bietti@sysaware.com">Alexis BIETTI
 *         &lt;alexis.bietti@sysaware.com&gt;</a>
 */
public class Labels {
  // Application names --------------------------------------------------------
  public static final String APP_DATABASE    = "Database";
  public static final String APP_LUCIOL_IO   = "Luciol I/O";
  public static final String APP_PASS_THRU   = "Pass Thru";
  public static final String APP_DNP3_MASTER = "DNP3 Master";
  public static final String APP_DNP3_SLAVE  = "DNP3 Slave";
  public static final String APP_IEC_103     = "IEC 103";

  // Database application -----------------------------------------------------
  public static final String DATABASE_DO_LONG_MAINTAIN_TIME =
    "Digital output - Long maintain time (s)";
  public static final String DATABASE_DO_SHORT_MAINTAIN_TIME =
    "Digital output - Short maintain time (ms)";

  // Pass Thru application ----------------------------------------------------
  public static final String PASS_THRU_IP_PORT      = "IP port number";
  public static final String PASS_THRU_COM_PORT     = "Com Port";
  public static final String PASS_THRU_BAUD_RATE    = "Baud Rate";
  public static final String PASS_THRU_DATA_BITS    = "Data Bits (5 to 8)";
  public static final String PASS_THRU_STOP_BITS    = "Stop Bits";
  public static final String PASS_THRU_PARITY       = "Parity";
  public static final String PASS_THRU_FLOW_CONTROL = "Flow Control";

  // RedirectionContext -------------------------------------------------------
  public static final String REDIRECTION_MESSAGE =
    "This server uses SSL and MUST be accessed with the HTTPS protocol.";

  // Titles -------------------------------------------------------------------
  public static final String FOOTER = "&copy; I.T. Lity 2002-2003";
  public static final String TITLE  = "LUCIOL &reg; Configuration Tool";
  public static final String SUBMIT = "Submit";
  public static final String RESET  = "Reset";

  // Error messages -----------------------------------------------------------
  public static final String ERROR_PARAM =
    "Some parameters are invalid or missing";
  public static final String ERROR_NOT_AUTHENTICATED =
    "You must <a href=/>open a session</a> to access the configurator";

  // Profiles -----------------------------------------------------------------
  public static final String[] PROFILES =
  { "Administrator", "Engineer", "Operator", "Maintenance" };

  // Servlet ------------------------------------------------------------------
  public static final String APPLICATION_SELECTION  = "Application Selection";
  public static final String DATABASE_CONFIGURATION =
    "Database Configuration";

  // Access Control Servlet ---------------------------------------------------
  public static final String ACCESS_CONTROL       = "Access Control";
  public static final String WRONG_TIME_PARAMETER = "Wrong time parameter";
  public static final String WRONG_SSL_PARAMETERS = "Wrong SSL parameters";
  public static final String SSL_WAS_SUCCESFULLY = "SSL was succesfully";
  public static final String ENABLED                       = "enabled";
  public static final String DISABLED                      = "disabled";
  public static final String ETHERNET_CONTROLER_PARAMETERS =
    "Ethernet Controller Parameters";
  public static final String IP_ADDRESS       = "IP Address";
  public static final String GATEWAY          = "Gateway";
  public static final String NET_MASK         = "Net Mask";
  public static final String PROMISCUOUS_MODE = "Promiscuous Mode";
  public static final String CHECK_TO_ENABLE = "Check to enable";

  // AppConfigurationServlet --------------------------------------------------
  public static final String XML_FILE_IS_NOT_VALID = "XML file is not valid";
  public static final String APPLICATION                 = "Application: ";
  public static final String MESSAGE                     = "Message: ";
  public static final String XML_FILE_LOADED_SUCCESFULLY =
    "XML file loaded succesfully";
  public static final String AN_ERROR_OCCURED_WHILE_COMMITING_THE_NEW_VALUES =
    "An error occured while commiting the new values";
  public static final String VALUE_OF_THE_PARAMETER =
    "Value of the parameter";
  public static final String IS_INCORRECT = "is incorrect";
  public static final String CONFIGURATION_UPDATED_SUCCESFULLY =
    "Configuration updated succesfuly";
  public static final String DOWNLOAD_ACTIVE_CONFIGURATION_AS =
    "Download active configuration as";
  public static final String XML_FILE                          = "XML file";
  public static final String DOWNLOAD_PASSIVE_CONFIGURATION_AS =
    "Download passive configuration as";
  public static final String UPLOAD_XML_FILE = "Upload XML file";
  public static final String GLOBAL_PARAMETERS = "Global Parameters";
  public static final String THIS_APPLICATION_HAS_NO_GLOBAL_PARAMETER =
    "This application has no global parameter";
  public static final String UNKNOWN = "Unknown";

  // AppSelectionServlet ------------------------------------------------------
  public static final String SELECTION_OF_APPLICATIONS =
    "Selection of Applications";
  public static final String ALL_APPLICATIONS_LAUNCHED_SUCCESFULLY =
    "All applications sessions launched successfully";
  public static final String SELECT_HOW_MANY_SESSIONS_YOU_WANT_FOR_EACH_APPLICATION =
    "Select how many sessions you want for each application";

  // DatabaseServlet ---------------------------------------------------------
  public static final String   DATABASE_DUMP = "Database Dump";
  public static final String   NEW_RECORD_WRITTEN_SUCCESFULLY =
    "New record written succesfully";
  public static final String   DATABASE_RECORDS   = "Database records";
  public static final String   LABEL              = "Label";
  public static final String   LOGIC              = "Logic";
  public static final String   MAINTAIN_SHORT     = "Short";
  public static final String   MAINTAIN_LONG      = "Long";
  public static final String   MAINTAIN_PERMANENT = "Permanent";
  public static final String   NORMAL             = "Normal";
  public static final String   INVERTED           = "Inverted";
  public static final String   DETECT_HIGH        = "High threshold";
  public static final String   DETECT_LOW         = "Low threshold";
  public static final String   LAW                = "Scaling law";
  public static final String[] LAWS               =
    new String[] {
      "Identity", "Linear: a.x + b", "Root square polynom: a.sqrt(x) + b",
      "Root squared linear: sqrt(a.x + b)"
    };
  public static final String UNIT = "Unit";

  // FileSystemServlet --------------------------------------------------------
  public static final String FILE_SYSTEM_DUMP        = "File System Dump";
  public static final String DIRECTORY_LISTING       = "Directory listing";
  public static final String ERASE_FLASH_FILE_SYSTEM =
    "Erase Flash File System";

  // EmailServlet -------------------------------------------------------------
  public static final String EMAIL_TITLE  = "E-mail configuration";
  public static final String RECIPIENT    = "Recipient";
  public static final String LUCIOL_EMAIL = "Luciol Address";
  public static final String POP_SERVER   = "POP server";
  public static final String SMTP_SERVER  = "SMTP server";
  public static final String POP_USER     = "Name";

  // BoxViewServlet -----------------------------------------------------------
  public static final String BOX_SELECT = "Choose a box";
  public static final String IO_SELECT = "Click on an I/O to configure it";
  public static final String BOX_VIEW_TITLE = "Configuration of I/Os";

  // Commit Servlet -----------------------------------------------------------
  public static final String COMMIT         = "Commit";
  public static final String COMMIT_CONFIRM =
    "Click YES to commit your changes:";
  public static final String COMMIT_OK = "Commit was succesful";

  // Roll back Servlet --------------------------------------------------------
  public static final String ROLLBACK         = "Roll Back";
  public static final String ROLLBACK_CONFIRM =
    "Click YES to roll back your changes:";
  public static final String ROLLBACK_OK     = "Roll back was succesful";
  public static final String ROLLBACK_FAILED = "Roll back failed";

  // MenuServlet --------------------------------------------------------------
  public static final String MENU_BROWSE = "Luciol I/O Configuration";

  // LoginServlet -------------------------------------------------------------
  public static final String THE_SERVER_IS_LOCKED_BY_A_USER =
    "The server is locked by a user.";
  public static final String PROFILE                = "Profile";
  public static final String PASSWORD               = "Password";
  public static final String LOGIN_FAILED           = "Login failed!";
  public static final String CLICK_HERE_TO_CONTINUE =
    "Click here to continue";

  // ConfigServlet & PropertyServlet ------------------------------------------
  public static final String MAIN_BOX = "Main box";
  public static final String AUX_BOX = "Aux. box";

  // IO Servlets --------------------------------------------------------------
  public static final String DIGITAL_OUTPUT        = "Digital Output";
  public static final String DIGITAL_INPUT         = "Digital Input";
  public static final String DIGITAL_OUTPUT_CARD   = "Digital Output Card";
  public static final String DIGITAL_INPUT_CARD    = "Digital Input Card";
  public static final String DOUBLE_INPUT          = "Double Input";
  public static final String DOUBLE_OUTPUT         = "Double Output";
  public static final String INTEGER_INPUT         = "Integer Input";
  public static final String SELECT_BEFORE_OPERATE = "Select Before Operate";
  public static final String ANALOG_OUTPUT         = "Analog Output";
  public static final String ANALOG_INPUT          = "Analog Input";
  public static final String ANALOG_OUTPUT_CARD    = "Analog Output Card";
  public static final String ANALOG_INPUT_CARD     = "Analog Input Card";

  // Passwords Servlet --------------------------------------------------------
  public static final String MENU_PASSWORDS   = "Access control";
  public static final String OLD_PASSWORD     = "Old password";
  public static final String NEW_PASSWORD     = "New Password";
  public static final String CONFIRM_PASSWORD = "Confirm new Password";
  public static final String PASSWORD_SUCCESS =
    "The password was changed successfuly.";
  public static final String PASSWORD_FAILED =
    "The password could not be changed.";
  public static final String PASSWORD_WRONG_PASSWORD = "Wrong password";
  public static final String PASSWORD_DONT_MATCH     =
    "Your passwords don't match";
  public static final String PASSWORD_TOO_SHORT =
    "Passwords must have at least 5 characters";

  // SystemServlet ------------------------------------------------------------
  public static final String SYSTEM          = "System";
  public static final String ACTIONS         = "Actions";
  public static final String TOTAL_MEM       = "Total memory";
  public static final String FREE_MEM        = "Free memory";
  public static final String USED_MEM        = "Used memory";
  public static final String MEM_USAGE       = "Memory usage";
  public static final String RUN_GC          = "Flush Memory";
  public static final String KILO_BYTES      = "Kilo Bytes";
  public static final String CURRENT_THREADS = "Current Threads";
  public static final String TIME_SYNCHRONIZATION = "Time Synchronization";
  public static final String CURRENT_SYSTEM_TIME = "Current system time";
  public static final String ENTER_THE_NAME_OF_AN_SNTP_SERVER =
    "Enter the name of an SNTP server";
  public static final String RESYNC_PERIOD_IN_MINUTES =
    "Resynchronization period in minutes";
  public static final String REBOOT = "Reboot the system";
  public static final String TIME_SETTING = "Time Setting";
  public static final String HOURS = "Hour";
  public static final String DATE = "Date";

  // ErrorServlet -------------------------------------------------------------
  public static final String ERROR_ERROR = "Error";
  public static final String ERROR_INVALID_REQUEST = "The server received an invalid request";
  public static final String RESOURCE = "Resource";
  public static final String METHOD = "Method";
  public static final String METHOD_NOT_SUPPORTED = "Method not supported";
  public static final String METHOD_NOT_ALLOWED_FOR_PROFILE = "Methode not authorised for the current profile";

  // QuitServlet --------------------------------------------------------------
  public static final String DISCONNECT   = "Disconnect";
  public static final String QUIT_CONFIRM =
    "Do you really want to close this session?";
  public static final String YES               = "Yes";
  public static String       NO                = "No";
  public static final String GOODBYE           = "Good Bye!";
  public static final String EMPTY_SLOT        = "Empty slot";
  public static final String UNKNOWN_CARD_TYPE = "Unknown card type";
  public static final String UNKNOWN_TYPE      = "Unknown type";

  //---------------------------------------------------------------------------
   // Master 103 _ English
   //---------------------------------------------------------------------------
   public static final String M103_COM_PORT = "Communication port";
   public static final String M103_BAUDRATE = "Baud rate";
   public static final String M103_TIMEOUT  = "Response timeout (seconds)";
   public static final String M103_RETRIES  = "Retries";
   public static final String M103_POLLING  = "Data class 2 polling cycle (seconds)";
   public static final String M103_NPOLL    =
	 "Maximum number of ASDUs per polling cycle";
   public static final String M103_SYNCHRO =
	 "Clock synchronization cycle (minutes)";
   public static final String M103_GI =
	 "General interrogation cycle (minutes)";
   public static final String M103_CAA		= "Default common address of ASDUs (1-255)";

   // end Master103 english labels
  
   //---------------------------------------------------------------------------
   // Master 101 _ English
   //---------------------------------------------------------------------------
	 public static final String M101_COM_PORT	= "Communication port";
	 public static final String M101_BAUDRATE	= "Baud rate";
	 public static final String M101_TIMEOUT		= "Response timeout (seconds)";
	 public static final String M101_RETRIES		= "Retries";
	 public static final String M101_POLLING		= "Data class 2 polling cycle (seconds)";
   public static final String M101_NPOLL		= "Maximum number of ASDUs per polling cycle";
	 public static final String M101_SYNCHRO		= "Clock synchronization cycle (minutes)";
	 public static final String M101_CAA		= "Default common address of ASDUs (1-255)";
//	 public static final String M101_OA		= "Originator address";
   public static final String M101_GI			= "General interrogation cycle (minutes)";
   public static final String M101_GI1			= "Group 1 interrogation cycle (minutes)";
   public static final String M101_GI2			= "Group 2 interrogation cycle (minutes)";
   public static final String M101_GI3			= "Group 3 interrogation cycle (minutes)";
   public static final String M101_GI4			= "Group 4 interrogation cycle (minutes)";
   public static final String M101_GI5			= "Group 5 interrogation cycle (minutes)";
   public static final String M101_GI6			= "Group 6 interrogation cycle (minutes)";
   public static final String M101_GI7			= "Group 7 interrogation cycle (minutes)";
   public static final String M101_GI8			= "Group 8 interrogation cycle (minutes)";
   public static final String M101_GI9			= "Group 9 interrogation cycle (minutes)";
   public static final String M101_GI10		= "Group 10 interrogation cycle (minutes)";
   public static final String M101_GI11		= "Group 11 interrogation cycle (minutes)";
   public static final String M101_GI12		= "Group 12 interrogation cycle (minutes)";
   public static final String M101_GI13		= "Group 13 interrogation cycle (minutes)";
   public static final String M101_GI14		= "Group 14 interrogation cycle (minutes)";
   public static final String M101_GI15		= "Group 15 interrogation cycle (minutes)";
   public static final String M101_GI16		= "Group 16 interrogation cycle (minutes)";
   public static final String M101_CITIME		= "Global counter interrogation (minutes)";
   public static final String M101_CI1TIME		= "Group 1 counter interrogation (minutes)";
   public static final String M101_CI2TIME		= "Group 2 counter interrogation (minutes)";
   public static final String M101_CI3TIME		= "Group 3 counter interrogation (minutes)";
   public static final String M101_CI4TIME		= "Group 4 counter interrogation (minutes)";
   public static final String M101_CIRAF		= "Global counter reset after freeze";
   public static final String M101_CI1RAF		= "Group 1 counter reset after freeze";
   public static final String M101_CI2RAF		= "Group 2 counter reset after freeze";
   public static final String M101_CI3RAF		= "Group 3 counter reset after freeze";
   public static final String M101_CI4RAF		= "Group 4 counter reset after freeze";
   public static final String M101_LNKSZ		= "Link address field size (1-2)";
   public static final String M101_COTSZ		= "Cause of transmission field size (1-2)";
   public static final String M101_CAASZ		= "Common address of asdus field size (1-2)";
   public static final String M101_IOASZ		= "Information object address field size (1-2-3)";
	
   // end Master101 english labels
   //---------------------------------------------------------------------------
   // Slave 101 _ English
   //---------------------------------------------------------------------------
	
   public static final String S101_COM_PORT		= "Communication port";
   public static final String S101_BAUDRATE		= "Baud rate";
   public static final String S101_ADDRESS			= "Address (1-254)";
   public static final String S101_CAA			= "Default common address of ASDUs (1-255)";
   public static final String S101_POLLING			= "Data class 2 refresh cycle (seconds)";
   public static final String S101_CLOCK			= "Enable change system clock";
   //public static final String S101_EXTENDEDTIME	= "Use extended time tags (CP56Time2a)";
   //public static final String S101_COUNTERTIME		= "Counter time reset (milliseconds)";
   public static final String S101_LNKSZ			= "Link address field size (1-2)";
   public static final String S101_COTSZ			= "Cause of transmission field size (1-2)";
   public static final String S101_CAASZ			= "Common address of asdus field size (1-2)";
   public static final String S101_IOASZ			= "Information object address field size (1-2-3)";
		
   // end Slave101 english labels

   //---------------------------------------------------------------------------
   // Slave 103 _ English
   //---------------------------------------------------------------------------
  
   public static final String S103_COM_PORT		= "Communication port";
   public static final String S103_BAUDRATE		= "Baud rate";
   public static final String S103_ID			= "Slave identication (12 bytes max.)";
   public static final String S103_ADDRESS		= "Address (1-254)";
   public static final String S103_FT			= "Default function type (1-255)";
   public static final String S103_CAA			= "Default common address of ASDUs (1-255)";
   public static final String S103_POLLING		= "Data class 2 refresh cycle (seconds)";
   public static final String S103_CLOCK			= "Enable change system clock";
		
   // end Slave 103 english labels
}


// end LocalStrings.java
