/*
 * Class    br.org.scadabr.protocol.iec101.common.CodeProperties
 * File     CodeProperties.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

/**
 * <p>
 * This class defines general properties of iec implementation
 * 
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */

public class CodeProperties {
	public static final boolean DEBUG = true;
	public static final boolean DEBUG_LINK = true;
	public static final boolean DEBUG_APPLICATION = true;
	public static final boolean DEBUG_PHYSICAL = true;

	public static final boolean RTS_WRITE = true;

	public static final boolean DUPLEX = true;

	public static final int AJILE_LSR_REGISTER = 0x9000814;

	public static final boolean AJILE = false;

	public static final boolean RS485 = false;

	/**
	 *
	 */
	public static final int PAUSE_BEFORE_WRITE = 0;
	public static final int PAUSE_AFTER_WRITE = 0;

	public static int FIFO_LAYER_SIZE = 500;

	public static int FIFO_SIZE = 1000;

	public static int FIFO_PROCEDURES = 10;

	public static final int FIFO_PROCEDURES_SIZE = 10;

	/**
	 * prints information from application layer
	 * 
	 * @param msg
	 *            log message
	 */
	public static void applog(String msg) {
		if (DEBUG_APPLICATION)
			System.out.println("[IECApp] " + msg);
	}

	/**
	 * prints information from link layer
	 * 
	 * @param msg
	 *            log message
	 */
	public static void lnklog(String msg) {
		if (DEBUG_LINK)
			System.out.println("[IECLnk] " + msg);
	}

	/**
	 * prints information from physical layer
	 * 
	 * @param msg
	 *            log message
	 */
	public static void phylog(String msg) {
		if (DEBUG_PHYSICAL)
			System.out.println("[IECPhy] " + msg);
	}

	/**
	 * prints debugging information
	 * 
	 * @param msg
	 *            log message
	 */
	public static void log(String msg) {
		if (DEBUG)
			System.out.println("[IECDbg] " + msg);
	}

}; // end CodeProperties.java