/*
 * Class    br.org.scadabr.protocol.iec101.common.Context
 * File     Context.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

/**
 * <p>
 * This class is aimed to hold all needed fields to define
 * a context for a station according to 10X implementation.
 * 
 * @author lionnel cauvy
 * @date 14.II.03
 * @version 1.0
 */
public abstract class Context
{
	/**
	 * Remote station address for master application, local station address
	 * for slave application.
	 */
	public int address;
	/**
	 * Remote station name for master application, local station name for
	 * slave application.
	 */
	public String name;
	/**
	 * Allocates a new context execution for an iec 870 application.
	 *
	 * @param address	Station address.
	 * @param name		Station identifier.
	 */
	public Context(int address, String name)
	{
		this.address = address;
	}
}