/*
 * Class    br.org.scadabr.protocol.iec101.common.FrameConverter
 * File     FrameConverter.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

/**
 * FrameConverter is used to turn frames into byte array<br>
 * It defines only a method convert to handle this operation.<br>
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
 
public class FrameConverter
{
	public static byte[] convert(Frame frame)
	{
		short checksum = 0;
		byte barray[] = new byte[0];
		short i = 0;
		switch (frame.type)
		{		
		case Frame.SINGLE:
			barray = new byte[1];
			barray[i++] = (byte)frame.start;
			break;			
			
		case Frame.FIXED:
			barray = new byte[3+Interoperability.FIXEDFRAMELENGTH];
			barray[i++] = (byte)frame.start;
			barray[i++] = (byte)frame.control.value;
			switch (Interoperability.ADDRESSFIELDLENGTH)
			{
			case 1:
				barray[i++] = (byte)frame.address;
				break;
			case 2:
				barray[i++] = (byte)(frame.address & 0xFF);
				barray[i++] = (byte)((frame.address & 0xFF00) >> 8);
				break;
			default:
				break;
			}
			for(short j=0;j<frame.user.data.size();j++)
				barray[i++] = (byte)(((Short)frame.user.data.elementAt(j)).shortValue());
			barray[i++] = (byte)frame.checksum;
			barray[i++] = (byte)frame.stop;
			break;			
			
		case Frame.VARIABLE:
			barray = new byte[6+frame.length];
			barray[i++] = (byte)frame.start;
			barray[i++] = (byte)frame.length;
			barray[i++] = (byte)frame.length;
			barray[i++] = (byte)frame.start;
			barray[i++] = (byte)frame.control.value;
			switch (Interoperability.ADDRESSFIELDLENGTH)
			{
			case 1:
				barray[i++] = (byte)frame.address;
				break;
			case 2:
				barray[i++] = (byte)(frame.address & 0xFF);
				barray[i++] = (byte)((frame.address & 0xFF00) >> 8);
				break;
			default:
				break;
			}
			for(short j=0;j<frame.user.data.size();j++)
				barray[i++] = (byte)(((Short)frame.user.data.elementAt(j)).shortValue());
			barray[i++] = (byte)frame.checksum;
			barray[i++] = (byte)frame.stop;
			break;			
			
		default:
			break;			
		}		
		return barray;
	}
}