/*
 * Class    br.org.scadabr.protocol.iec101.common.InformationObject
 * File     InformationObject.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

import java.util.Vector;

/**
 * Information object is user data contained by a frame.
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */

public class InformationObject
{
	/**
	 * Information element sequence.
	 */
	public Vector ie;

	/**
	 * Object address.
	 */	
	public int address;

	/**
	 * Add an element to information elements hold by this
	 * information object.
	 *
	 * @param element	The information element to add.
	 */	
	public void setElement(InformationElement element)
	{
		ie.addElement(element);
	}
	
	/**
	 * Allocate an information object.
	 */
	public InformationObject()
	{
		ie = new Vector();
		// time tag????
	}
	
};	// end InformationObject.java