/*
* Class    br.org.scadabr.protocol.iec101.common.PeriodicEventListener
* File     PeriodicEventListener.java
* Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

import br.org.scadabr.protocol.iec101.common.*;

/**
 * <p>
 * This interface enables objects to use a periodic task.
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 29.XII.02
 */
public interface PeriodicEventListener
{
  /**
   * This event is raised by a periodic task.
   *
   * @param svc		The application service recorded as periodic procedure.
   * @param count	Trigger count.
   */
  public abstract void triggerEvent(AppService svc, int count);
}	// end PeriodicEventListener.java
