package br.org.scadabr.protocol.iec101.common;

import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

import br.org.scadabr.luciol.ajile.components.CallbackTimer;

public class PhyEthernetLayer extends PhysicalLayer {

	private String host = "150.162.165.190";
	private int port = 2404;
	private Socket socket;

	public PhyEthernetLayer() {
	}

	public PhyEthernetLayer(String host, int port) {
		this.host = host;
		this.port = port;
	}

	@Override
	protected void write(byte[] data) {
		try {
			output.write(data);
			output.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void launch() {
		try {
			socket = new Socket(host, port);
			input = socket.getInputStream();
			output = socket.getOutputStream();
			this.attempt = 0;
			this.timer = CallbackTimer.getInstance();
		} catch (UnknownHostException e) {
			kill();
			upper.lowerKill();
			e.printStackTrace();
			return;
		} catch (IOException e) {
			kill();
			upper.lowerKill();
			e.printStackTrace();
			return;
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}

		controller = new Controller(this);
		// creates a new receiver object givin him reference to the
		// controller to wich receiver will send read bytes.
		receiver = new Receiver(controller, input);

	}

	@Override
	public void kill() {
		try {
			if (timer != null)
				timer.removeCallback(this);
			if (controller != null) {
				controller.kill();
				controller.join();
			}
			if (receiver != null) {
				receiver.kill();
				receiver.join();
			}
			if (input != null) {
				input.close();
			}
			if (output != null) {
				output.close();
			}
		} catch (Exception e) {
			return;
		}

	}

}
