/*
 * Class    br.org.scadabr.protocol.iec101.common.PrivateElement
 * File     PrivateElement.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common;

/**
 * <p>
 * This class defines generic private element
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
 
public abstract class PrivateElement
{		
	/**
	 * identification octet value
	 */
	public short id;	
	
	/**
	 * element label
	 */
	public String label;
	
	/**
	 * allocates a private element for iec608705 protocol
	 *
	 * @param type		private element type
	 * @param remote	remote address	
	 * @param value		octet value
	 * @param label		label to comment this asdu
	 */	
	protected PrivateElement(short id, String label)
	{
		this.id = id;
		this.label = label;
	}
	
};	// end PrivateElement.java