/*
 * Class    br.org.scadabr.protocol.iec101.common103.Asdu103
 * File     Asdu103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common103;

import br.org.scadabr.protocol.iec101.common.Asdu;
import br.org.scadabr.protocol.iec101.common.IEC608705Exception;
import br.org.scadabr.protocol.iec101.common.InformationElement;
import br.org.scadabr.protocol.iec101.common.InformationObject;

/**
 * Asdu application service data unit for 103 protocol
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class Asdu103 extends Asdu
{
	/**
	 * function type
	 */
	public short ft;
	/**
	 * information number
	 */
	public short in;	
	/**
	 * Get accessor on a single value hold by asdu from its index positions.
	 *
	 * @param pio	Position of an io into sequence of information objects. From zero value.
	 * @param pie	Position of an ie into sequence of information elements. From zero value.
	 * @param pval	Position of value into sequence of values. From zero value.
	 *
	 * @return the value as an Object. It can be a Byte, a Short, a Math32FP, a Float....
	 */
	public Object value(int pio, int pie, int pval) throws IEC608705Exception
	{
		InformationObject obj = (InformationObject)io.elementAt(pio);
		InformationElement elt = (InformationElement)obj.ie.elementAt(pie);
		return 	elt.dataset[pval];	
	}	
	/**
	 * empty constructor
	 */
	public Asdu103()
	{
	}
	
};	// end Asdu103.java