/*
 * Class    br.org.scadabr.protocol.iec101.common103.ToBinaryFormatter103
 * File     ToBinaryFormatter103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common103;

import br.org.scadabr.protocol.iec101.common.Translator;

/**
 * Translation rule is 103 dpi or dco on:<1> off:<2> cast.
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class ToBinaryFormatter103 implements Translator
{
	/**
	 * Binary POSITIVE/NEGATIVE logic.
	 */
	public boolean logic;
	
	private static final Boolean TRUE	= new Boolean(true);
	private static final Boolean FALSE	= new Boolean(false);
	
	/**
	 * Applies a binary modification operation on a data element
	 * from iec information element.
	 *
	 * @param obj	the object to transform
	 *
	 * @return a byte <0x02> ON	<0x01> OFF
	 */
	public Object apply(Object obj)
	{
		if (logic)
		{
			if(((Byte)obj).byteValue()==0x02)
				return TRUE;
			else
				return FALSE;
		}
		else
		{
			if(((Byte)obj).byteValue()==0x02)
				return FALSE;
			else
				return TRUE;
		}	
	}

	/**
	 * <p>
	 * Constructs a 103 formatter object.
	 *
	 * @param logic		true:+ false:-
	 */	
	public ToBinaryFormatter103(boolean logic)
	{
		this.logic = logic;
	}
	
};	// end ToBinaryFormatter103.java