/*
 * Class    br.org.scadabr.protocol.iec101.common103.information.GID
 * File     GID.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common103.information;

import br.org.scadabr.protocol.iec101.common.InformationElement;

/**
 * <b>Generic identification data 7.2.6.33</b><br>
 * <p><i>
 * GID := CP8*i<br>
 * with<br>
 * i := DATASIZE multiplied with NUMBER, except for use of bitstrings (see 7.2.6.32).<br>
 * </i>
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */

public class GID extends InformationElement
{
	/**
	 * GID value
	 */
	  
	/**
	 * constructs GID object<br>
	 * generic information data 7.2.6.33
	 * @param octet value of 'physical' data in a short array
	 */
	public GID(short[] octet)
	{
		super(octet.length,1);
		octetset = octet;
		decode();
	}
	
	protected void decode()
	{
	}
	
	protected void code()
	{
	}
	
	public GID()
	{
		super(0,0);
	}
	
};	// end GID.java