/*
 * Class    br.org.scadabr.protocol.iec101.common103.information.SCN
 * File     SCN.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common103.information;

import br.org.scadabr.protocol.iec101.common.InformationElement;

/**
 * <b>Scan number 7.2.6.21</b><br>
 * <p><i>
 * SCN := UI8 [1..8] <0..255>
 * </i>
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */

public class SCN extends InformationElement
{
	/**
	 * constructs SCN object<br>
	 * scan number 7.2.6.21
	 * @param octet value of 'physical' data
	 */
	public SCN(short octet)
	{
		super(1,1);
		octetset[0] = octet;
		decode();
	}
		
	/**
	 * builds sub information data from 'physical' data.
	 * called when physical data is all known
	 */	
	protected void decode()
	{
		dataset[0] = new Short(octetset[0]);
	}
	
	/**
	 * builds  'physical' data from sub information data.
	 * called when sub information data is all known
	 */	
	protected void code()
	{
		octetset[0] = ((Short)dataset[0]).shortValue();
	}
	
	/**
	 * default constructor
	 */	
	public SCN()
	{
		super(1,1);//? counter to increment --> gi app method
	}
	
};	// end SCN.java