/*
 * Class    br.org.scadabr.protocol.iec101.common103.information.TAG
 * File     TAG.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.common103.information;

import br.org.scadabr.protocol.iec101.common.InformationElement;

/**
 * tag
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */

public class TAG extends InformationElement
{	
	/**
	  *
	  */
	//private short functionType;			--> dataset[0]
		
	/**
	  *
	  */
	//private short informationNumber;		--> dataset[1]
		
	/**
	  *
	  */
	//private DPI dpi;						--> dataset[2]
	
	/**
	 * constructs TAG object<br>
	 * for asdu 29
	 * @param octet1 value of first octet of 'physical' data
	 * @param octet2 second octet
	 * @param octet3 third octet
	 */
	public TAG(short octet1, short octet2, short octet3)
	{
		super(3,3);
		octetset[0] = octet1;
		octetset[1] = octet2;
		octetset[2] = octet3;
		decode();
	}

	/**
	 * builds sub information data from 'physical' data.
	 * called when physical data is all known
	 */
	protected void decode()
	{
		dataset[0] = new Short(octetset[0]);
		dataset[1] = new Short(octetset[1]);
		dataset[2] = new Byte((byte)(octetset[2]&0x03));
		// RESERVE ON OCTET2 _ SEE ALSO DPI DCO
	}
	
	/**
	 * builds  'physical' data from sub information data.
	 * called when sub information data is all known
	 */	
	protected void code()
	{
		octetset[0] = ((Short)dataset[0]).shortValue();
		octetset[1] = ((Short)dataset[1]).shortValue();
		octetset[2] = ((Byte)dataset[2]).byteValue();
	}
	
	/**
	 * default constructor
	 */
	public TAG()
	{
		super(3,3);
	}
	
};	// end TAG.java