/*
 * Class    br.org.scadabr.protocol.iec101.master.MPoll1LnkSvc
 * File     MPoll1LnkSvc.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines link service for polling user data class 1
 * of a remote station according to its address.
 * <p>
 * User data class 1 type stands for spontaneous events happening
 * from a remote.
 * <p>
 * This service is only available for master applications.
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class MPoll1LnkSvc extends MLnkService
{
	/**
	 * Allocates a new polling user data class 1 link service.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */	
	public MPoll1LnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RR_USER_DATA_CLASS_1,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S3_RESPOND_USER_DATA,
			Interoperability.SERVICE_S3_RESPOND_NACK
		);
	}
	
}	// end MPoll1LnkSvc.java
