/*
 * Class    br.org.scadabr.protocol.iec101.master.MPoll2LnkSvc
 * File     MPoll2LnkSvc.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines link service for polling user data class 2
 * of a remote station according to its address.
 * <p>
 * User data class 2 type stands for cyclic data such as measures
 * performed by a remote.
 * <p>
 * This service is only available for master applications.
 *
 * @author lionnel cauvy
 * @version 2.0
 * @date 01.II.03
 */
public class MPoll2LnkSvc extends MLnkService
{
	/**
	 * Allocates a new polling user data class 2 link service.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */	
	public MPoll2LnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RR_USER_DATA_CLASS_2,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S3_RESPOND_USER_DATA,
			Interoperability.SERVICE_S3_RESPOND_NACK
		);
	}
	
};	// end MPoll2LnkSvc.java
