/*
 * Class	br.org.scadabr.protocol.iec101.master.MReqACDLnkSvc
 * File		MReqACDLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'request access demand' service at link layer level.
 * <p>
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MReqACDLnkSvc extends MLnkService
{
	/**
	 * Allocates a link service object for remote access demand request.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MReqACDLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RR_ACCESS_DEMAND,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S3_RESPOND_USER_DATA,
			Interoperability.SERVICE_S3_RESPOND_NACK
		);
	}	
}	// end MReqACDLnkSvc.java
