/*
 * Class	br.org.scadabr.protocol.iec101.master.MReqStatusLnkSvc
 * File		MReqStatusLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'request link status' service at link layer level.
 * <p>
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MReqStatusLnkSvc extends MLnkService
{
	/**
	 * Allocates a link service object for remote link status request.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MReqStatusLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RR_LINK_STATUS,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S3_RESPOND_LINK_STATUS_OR_ACD,
			Interoperability.SERVICE_S3_RESPOND_NACK
		);
	}	
}	// end MReqStatusLnkSvc.java
