/*
 * Class	br.org.scadabr.protocol.iec101.master.MResetFcbLnkSvc
 * File		MResetFcbLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;
/**
 * <p>
 * This class defines 'reset frame count bit' service at link layer level.
 * <p>
 * This initializarion mode only resets FCB of a remote without cleaning
 * communication buffers. Frame count bit is an alternate bit that allows to
 * identify user data exchange between stations.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MResetFcbLnkSvc extends MLnkService
{
	/**
	 * Allocates a link service object for remote frame count bit reset.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MResetFcbLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S2_SC_RESET_FCB,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S2_CONFIRM_ACK,
			Interoperability.SERVICE_S2_CONFIRM_NACK
		);
	}	
}	// end MResetFcbLnkSvc.java

