/*
 * Class	br.org.scadabr.protocol.iec101.master.MResetProcessLnkSvc
 * File		MResetProcessLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'reset ruser process' service at link layer level.
 * <p>
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MResetProcessLnkSvc extends MLnkService
{
	/**
	 * Allocates a link service object for remote user process reset.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MResetProcessLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S2_SC_RESET_USER_PROCESS,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S2_CONFIRM_ACK,
			Interoperability.SERVICE_S2_CONFIRM_NACK
		);
	}	
}	// end MResetProcessLnkSvc.java

