/*
 * Class	br.org.scadabr.protocol.iec101.master.MSendConfirmaSvc
 * File		MSendConfirmLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;
/**
 * <p>
 * This class defines 'send user data with confirmation' service at
 * link layer level.
 * <p>
 * Such a service procedure allows to send some asdu to a remote. Acknoweledgement
 * of reception status is expected as a return from this remote. Sending asdu can
 * also be performed without awaiting any acknoweledgement: Send No Reply.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MSendConfirmLnkSvc extends MLnkService
{
	/**
	 * User data as a short array.
	 */
	public short[] uData;
	/**
	 * Allocates a link service object for remote link reset.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MSendConfirmLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S2_SC_USER_DATA,
			manager.address,
			manager.fcb,
			manager.fcv,
			Interoperability.SERVICE_S2_CONFIRM_ACK,
			Interoperability.SERVICE_S2_CONFIRM_NACK
		);
	}	
}	// end MSendConfirmLnkSvc.java

