/*
 * Class	br.org.scadabr.protocol.iec101.master.MSendNoReplyLnkSvc
 * File		MSendNoReplyLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'send user data without confirmation' service at
 * link layer level.
 * <p>
 * Such a service procedure allows to send some asdu to a remote.
 * Sending asdu can also be performed with a required acknoweledgement:
 * Send Confirm.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class MSendNoReplyLnkSvc extends MLnkService
{
	/**
	 * User data as a short array.
	 */
	public short[] uData;
	/**
	 * Allocates a link service object for remote link reset.
	 *
	 * @param manager	Link manager or context reference that gives FCB,FCV,PRM...
	 */
	public MSendNoReplyLnkSvc(MLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S1_SN_USER_DATA,
			manager.address,
			manager.fcb,
			manager.fcv,
			NOTUSED,
			NOTUSED
		);
	}	
}	// end MSendNoReplyLnkSvc.java

