/*
 * Class    br.org.scadabr.protocol.iec101.master101.MPoll2AppSvc101
 * File     MPoll2AppSvc101.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master101;

import br.org.scadabr.protocol.iec101.common.DbLocator;
import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master.MLnkManager;
import br.org.scadabr.protocol.iec101.master.MPoll1LnkSvc;
import br.org.scadabr.protocol.iec101.master.MSvcId;

/**
 * <p>
 * This class defines a 'polling measures' mechanism.
 * <p>
 * ///// IEC DESCRIPTION
 * <p>
 * This class extends MAppSvc, and general contract for such a class is to
 * format the procedure to make it match with a standardized application
 * procedure.
 * 
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class MPoll1AppSvc101 extends MAppService {
	/**
	 * <p>
	 * Constructs a new polling data class 1 procedure triggered by database
	 * notification.
	 * 
	 * @param manager
	 *            Application layer manager.
	 * @param notifier
	 *            Database locator notifier.
	 */
	public MPoll1AppSvc101(MAppManager manager, DbLocator notifier) {
		super(
		// no asdu to build
				null,
				// related link service
				new MPoll1LnkSvc((MLnkManager) manager.lnk),
				// procedure identifier
				new MSvcId(MAppServiceIfc101.S12_POLLING,
						MAppServiceIfc101.S12_PRIORITY),
				// luciol database notifier
				notifier,
				// execution context
				manager.context,
				// expected asdu
				null
		// new AsduKey101(
		// (short)NOTUSED,
		// (short)NOTUSED,
		// Interoperability101.COT_PERIODIC_CYCLIC,
		// (short)NOTUSED,
		// NOTUSED
		// )
		);
	}
} // end MPoll2AppSvc101.java
