/*
 * Class    br.org.scadabr.protocol.iec101.master101.MReadAppSvc101
 * File     MReadAppSvc101.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master101;

import br.org.scadabr.protocol.iec101.common.DbLocator;
import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common101.AsduKey101;
import br.org.scadabr.protocol.iec101.common101.Interoperability101;
import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master.MLnkManager;
import br.org.scadabr.protocol.iec101.master.MSendConfirmLnkSvc;
import br.org.scadabr.protocol.iec101.master.MSvcId;

/**
 * <p>
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.IV.03
 */
public class MReadAppSvc101 extends MAppService
{
	/**
	 * Information object address.
	 */
	public int ioa;
	/**
	 * Instanciates a new triggered read command asdu.
	 *
	 * @param manager	Application layer manager.
	 * @param notifier	Luciol database notifier.
	 * @param caa		Common address of asdus.
	 * @param ioa		Information object address to read.
	 */		
	public MReadAppSvc101(MAppManager manager, DbLocator notifier, int caa, int ioa)
	{
		super(
			// asdu to build
			new MapAsdu(
				new AsduKey101(
					Interoperability101.ID_C_RD_NA_1,
					(short)1,
					Interoperability101.COT_REQUEST,
					(short)NOTUSED,
					caa
				)
			),
			// related link service
			new MSendConfirmLnkSvc((MLnkManager)manager.lnk),
			// procedure identifier
			new MSvcId(
				MAppServiceIfc101.S6_READ_COMMAND,
				MAppServiceIfc101.S6_PRIORITY					
			),
			// database locator as luciol notifier
			notifier,
			// execution context
			manager.context,
			// expected ok asdu
			new AsduKey101(
				(short)NOTUSED,
				(short)NOTUSED,
				Interoperability101.COT_REQUEST,
				(short)NOTUSED,
				NOTUSED
			)
//			// expected ko asdu
//			new AsduKey101(
//				Interoperability101.ID_C_RD_NA_1,
//				(short)NOTUSED,
//				(short)NOTUSED,
//				(short)NOTUSED,
//				NOTUSED
//			)	
		);
		this.ioa	= ioa;	
	}	
}	// end MReadAppSvc101.java
