/*
 * Class    br.org.scadabr.protocol.iec101.master101.MResetProcessAppSvc101
 * File     MResetProcessAppSvc101.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master101;

import br.org.scadabr.protocol.iec101.common.DbLocator;
import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common101.AsduKey101;
import br.org.scadabr.protocol.iec101.common101.Interoperability101;
import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master.MLnkManager;
import br.org.scadabr.protocol.iec101.master.MSendConfirmLnkSvc;
import br.org.scadabr.protocol.iec101.master.MSvcId;

/**
 * <p>
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.IV.03
 */
public class MResetProcessAppSvc101 extends MAppService
{
	/**
	 * Information object address = 0.
	 */
	public int ioa = 0;
	/**
	 *
	 */
	public byte qrp = 1;
	/**
	 * Instanciates a new triggered reset process command asdu.
	 *
	 * @param manager	Application layer manager.
	 * @param notifier	Luciol database notifier.
	 * @param caa		Common address of asdus.
	 */		
	public MResetProcessAppSvc101(MAppManager manager, DbLocator notifier, int caa)
	{
		super(
			// asdu to build
			new MapAsdu(
				new AsduKey101(
					Interoperability101.ID_C_RP_NA_1,
					(short)1,
					Interoperability101.COT_ACTIVATION,
					(short)NOTUSED,
					caa
				)
			),
			// related link service
			new MSendConfirmLnkSvc((MLnkManager)manager.lnk),
			// procedure identifier
			new MSvcId(
				MAppServiceIfc101.S8_RESET_PROCESS_COMMAND,
				MAppServiceIfc101.S8_PRIORITY					
			),
			// database locator as luciol notifier
			notifier,
			// execution context
			manager.context,
			// expected ok asdu
			new AsduKey101(
				Interoperability101.ID_C_RP_NA_1,
				(short)NOTUSED,
				Interoperability101.COT_ACTIVATIONCONF,
				(short)NOTUSED,
				NOTUSED
			)
		);
	}	
}	// end MResetProcessAppSvc101.java
