/*
 * Class    br.org.scadabr.protocol.iec101.master103.MContext103
 * File     MContext103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master103;

import br.org.scadabr.protocol.iec101.common.Context;
/**
 * <p>
 * This class defines all application internal data to update according
 * to transmission exchanges with a remote slave.
 * <p>
 * Therefore, we can find here variables Scan Number for general interrogation
 * counting, Return Information Identifier to associate to a general command,
 * double command value....
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class MContext103 extends Context
{
	public int gi;
	/**
	 * Scan number.
	 */
	public short scn;
	/**
	 * Return Information Identifier.
	 */
	public short rii;
	/**
	 * Double Command.
	 */
	public short dco;
	
	/**
	 * <p>
	 * Allocates an execution context (current values for application
	 * variables) for a master 103 application according to A remote
	 * station.
	 *
	 * @param address	Remote station address.
	 * @param name		Remote station string identifier.
	 */
	public MContext103(int address, String name)
	{
		super(address,name);
		scn = 0;
		rii = 0;
		dco = 0;
	}
}	// end MContext103.java
