/*
 * Class    br.org.scadabr.protocol.iec101.master103.MProcedure103
 * File     MProcedure103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.master103;


public interface MProcedure103
{
	/**
	 * initial procedure: ResetCU + Synchro + General interrogation.
	 */
	public static final byte	S0_INITIAL					= 0x00;
	/**
	 * application service for station initialization by reseting communication unit.
	 */
	public static final byte	S1_RESET_CU					= 0x01;
	/**
	 * application service for station initialization by reseting frame count bit.
	 */
	public static final byte	S2_RESET_FCB				= 0x02;
	/**
	 * application service for station time synchronization
	 */
	public static final byte	S3_TIME_SYNCHRONIZATION		= 0x03;
	/**
	 * application service for station general interrogation
	 */
	public static final byte	S4_GENERAL_INTERROGATION	= 0x04;
	/**
	 * application service for station generic data
	 */
	public static final byte	S5_GENERIC_DATA				= 0x05;
	/**
	 * application service for station general command
	 */
	public static final byte	S6_GENERAL_COMMAND			= 0x06;
	/**
	 * application service for station generic command
	 */
	public static final byte	S7_GENERIC_COMMAND			= 0x07;
	/**
	 * application service for station cyclic measurements
	 */
	public static final byte	S8_POLLING					= 0x08;
	/**
	 * application service for station test mode
	 */
	public static final byte	S9_TEST_MODE				= 0x09;
	/**
	 * application service for station monitoring direction
	 * blocking messages
	 */
	public static final byte	S10_BLOCK					= 0x0A;
	/**
	 * application service for order disturbance data
	 */
	public static final byte	S11_ORDER_DISTURBANCE		= 0x0B;
	/**
	 * application service for ack disturbance data
	 */
	public static final byte	S12_ACK_DISTURBANCE			= 0x0C;
	
	public static final int PRIORITY_GIC_DATA				= -1;
	
	public static final int PRIORITY_GIC_CD					= -1;
	
	public static final int PRIORITY_TEST					= -1;
	
	public static final int PRIORITY_BLOCK					= -1;
	
	public static final int PRIORITY_ORDER_DIST				= -1;
	
	public static final int PRIORITY_ACK_DIST				= -1;
	
	public static final int S0_PRIORITY		= 0;
	
	public static final int S1_PRIORITY		= 6;
	
	public static final int S2_PRIORITY		= 5;
	
	public static final int S6_PRIORITY		= 4;
	
	public static final int S3_PRIORITY		= 3;
	
	public static final int S4_PRIORITY		= 2;
	
	public static final int S8_PRIORITY		= 1;
	
}	// end MProcedure103.java