package br.org.scadabr.protocol.iec101.session;

public class IECConfig {
	private int linkAddress = 1;
	private int asduAddress = 3;
	private int retries = 100;
	private int timeout = 1000;
	private byte cotSize = 1;
	private byte asduAddressSize = 2;
	private byte objectAddressSize = 2;
	private byte linkAddressSize = 1;
	private String serialPort = "COM2";
	private int baudrate = 9600;
	private int databits = 8;
	private int parity = 0;
	private int stopbits = 2;
	private String host = "localhost";
	private int port = 2404;

	private COMM commType = COMM.SERIAL;

	public IECConfig() {
	}

	public IECConfig(String serialPort, int baudrate, int databits) {
		this.serialPort = serialPort;
		this.baudrate = baudrate;
		this.databits = databits;
		this.setCommType(COMM.SERIAL);
	}

	public IECConfig(String host, int port) {
		this.host = host;
		this.port = port;
		this.setCommType(COMM.ETHERNET);
	}

	public enum COMM {
		ETHERNET, SERIAL
	}

	public int getRetries() {
		return retries;
	}

	public void setRetries(int retries) {
		this.retries = retries;
	}

	public int getTimeout() {
		return timeout;
	}

	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}

	public byte getCotSize() {
		return cotSize;
	}

	public void setCotSize(byte cotSize) {
		this.cotSize = cotSize;
	}

	public byte getAsduAddressSize() {
		return asduAddressSize;
	}

	public void setAsduAddressSize(byte asduAddressSize) {
		this.asduAddressSize = asduAddressSize;
	}

	public byte getObjectAddressSize() {
		return objectAddressSize;
	}

	public void setObjectAddressSize(byte objectAddressSize) {
		this.objectAddressSize = objectAddressSize;
	}

	public byte getLinkAddressSize() {
		return linkAddressSize;
	}

	public void setLinkAddressSize(byte linkAddressSize) {
		this.linkAddressSize = linkAddressSize;
	}

	public int getBaudrate() {
		return baudrate;
	}

	public void setBaudrate(int baudrate) {
		this.baudrate = baudrate;
	}

	public int getDatabits() {
		return databits;
	}

	public void setDatabits(int databits) {
		this.databits = databits;
	}

	public int getParity() {
		return parity;
	}

	public void setParity(int parity) {
		this.parity = parity;
	}

	public int getStopbits() {
		return stopbits;
	}

	public void setStopbits(int stopbits) {
		this.stopbits = stopbits;
	}

	public void setLinkAddress(int linkAddress) {
		this.linkAddress = linkAddress;
	}

	public int getLinkAddress() {
		return linkAddress;
	}

	public void setAsduAddress(int asduAddress) {
		this.asduAddress = asduAddress;
	}

	public int getAsduAddress() {
		return asduAddress;
	}

	public String getSerialPort() {
		return serialPort;
	}

	public void setSerialPort(String serialPort) {
		this.serialPort = serialPort;
	}

	public String getHost() {
		return host;
	}

	public void setHost(String host) {
		this.host = host;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}

	public void setCommType(COMM commType) {
		this.commType = commType;
	}

	public COMM getCommType() {
		return commType;
	}

}
