package br.org.scadabr.protocol.iec101.session;

public class Response {
	private short cot = 0;
	private boolean acd = false;
	private byte controlFunction = -1;

	public boolean isAckOrNack() {
		if (controlFunction == (byte) 0x00)
			return true;
		else if (controlFunction == (byte) 0x09)
			return true;
		return false;
	}

	public boolean isActivationConfirmation() {
		if (cot == 0x07)
			return true;
		return false;
	}

	public boolean isActivationTermination() {
		if (cot == 10)
			return true;
		return false;
	}

	public boolean isAck() {
		if (controlFunction == (byte) 0x00)
			return true;
		return false;
	}

	public boolean isStatusOfLink() {
		if (controlFunction == (byte) 11)
			return true;
		return false;
	}

	public short getCot() {
		return cot;
	}

	public void setCot(short cot) {
		this.cot = cot;
	}

	public boolean isAcd() {
		return acd;
	}

	public void setAcd(boolean acd) {
		this.acd = acd;
	}

	public byte getControlFunction() {
		return controlFunction;
	}

	public void setControlFunction(byte controlFunction) {
		this.controlFunction = controlFunction;
	}
}
