package br.org.scadabr.protocol.iec101.session.commands;

import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master101.MPoll1AppSvc101;
import br.org.scadabr.protocol.iec101.master101.MPoll2AppSvc101;
import br.org.scadabr.protocol.iec101.session.CompositeMessage;
import br.org.scadabr.protocol.iec101.session.Response;

public class ClassPoll implements CompositeMessage {
	private int state = 0;
	private MAppManager manager;
	private boolean finished = false;

	private MAppService services[];

	public ClassPoll(MAppManager manager) {
		this.manager = manager;
		services = new MAppService[2];
		services[0] = new MPoll2AppSvc101(manager, null);
		services[1] = new MPoll1AppSvc101(manager, null);
	}

	@Override
	public MAppService nextMessage() {
		if (state == 0) {
			return services[0];
		} else if (state == 1) {
			return services[1];
		}
		return null;
	}

	@Override
	public int responseReceived(Response response) {
		if (state == 0) {
			if (response.isAckOrNack() && response.isAcd()) {
				state = 1;
				return CONTINUE;
			} else
				return SUCCESS;
		} else
			return SUCCESS;
	}

}
