package br.org.scadabr.protocol.iec101.session.commands;

import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master101.MGeneralInterrogationAppSvc101;
import br.org.scadabr.protocol.iec101.master101.MPoll2AppSvc101;
import br.org.scadabr.protocol.iec101.session.CompositeMessage;
import br.org.scadabr.protocol.iec101.session.Response;

public class GeneralInterrogation implements CompositeMessage {
	private int state = 0;
	private MAppManager manager;
	private boolean finished = false;

	private MAppService services[];

	public GeneralInterrogation(MAppManager manager) {
		this.manager = manager;
		services = new MAppService[2];
		services[0] = new MGeneralInterrogationAppSvc101(manager, null, 3,
				(short) 0);
		services[1] = new MPoll2AppSvc101(manager, null);
	}

	@Override
	public MAppService nextMessage() {
		if (state == 0) {
			System.out.println("Iniciando GENERAL INTERROGATION!");
			// general interrogation
			return services[0];
		} else if (state == 1 || state == 2) {
			// class2Request
			return services[1];
		}
		return null;
	}

	@Override
	public int responseReceived(Response response) {
		if (state == 0) {
			if (response.isAck()) {
				state++;
				return CONTINUE;
			} else
				return FAILED;
		} else if (state == 1) {
			if (response.isActivationConfirmation()) {
				state = 2;
				return CONTINUE;
			} else if (response.isAckOrNack()) {
				return CONTINUE;
			} else {
				return FAILED;
			}
		} else if (state == 2) {
			if (response.isActivationTermination()) {
				state = 3;
				finished = true;
				return SUCCESS;
			} else {
				return CONTINUE;
			}
		}
		return FAILED;
	}

}
