package br.org.scadabr.protocol.iec101.session.commands;

import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master101.MReqStatusAppSvc101;
import br.org.scadabr.protocol.iec101.master101.MResetCuAppSvc101;
import br.org.scadabr.protocol.iec101.session.CompositeMessage;
import br.org.scadabr.protocol.iec101.session.Response;

public class InitializationCommand implements CompositeMessage {
	private int state = 0;
	private MAppManager manager;
	private boolean finished = false;

	private MAppService services[];

	public InitializationCommand(MAppManager manager) {
		this.manager = manager;
		services = new MAppService[2];
		services[0] = new MReqStatusAppSvc101(manager, null);
		services[1] = new MResetCuAppSvc101(manager, null);
	}

	@Override
	public MAppService nextMessage() {
		if (state == 0) {
			System.out.println("Request Status of Link!");
			return services[0];
		} else if (state == 1) {
			return services[1];
		}
		return null;
	}

	@Override
	public int responseReceived(Response response) {
		if (state == 0) {
			if (response.isStatusOfLink()) {
				state++;
				return CONTINUE;
			} else
				return FAILED;
		} else if (state == 1) {
			if (response.isAck())
				return SUCCESS;
			else
				return FAILED;
		}
		return FAILED;
	}

}
