package br.org.scadabr.protocol.iec101.session.commands;

import br.org.scadabr.protocol.iec101.common.DbLocator;
import br.org.scadabr.protocol.iec101.master.MAppManager;
import br.org.scadabr.protocol.iec101.master.MAppService;
import br.org.scadabr.protocol.iec101.master101.MCommandAppSvc101;
import br.org.scadabr.protocol.iec101.master101.MPoll2AppSvc101;
import br.org.scadabr.protocol.iec101.session.CompositeMessage;
import br.org.scadabr.protocol.iec101.session.Response;

public class SingleCommand implements CompositeMessage {

	private MAppManager manager;
	private boolean select = false;

	public SingleCommand(MAppManager manager, int ioa, boolean select,
			byte qualifier, boolean value) {
		this.manager = manager;

		if (!select) {
			services = new MAppService[2];
			byte state = 0x01;
			if (!value)
				state = 0;
			services[0] = new MCommandAppSvc101(manager, (DbLocator) null,
					(byte) 45, 3, ioa, true, state, qualifier, true);
			services[1] = new MPoll2AppSvc101(manager, null);
		} else {
			this.select = true;
			services = new MAppService[3];
			byte state = 0x01;
			if (!value)
				state = 0;
			services[0] = new MCommandAppSvc101(manager, (DbLocator) null,
					(byte) 45, 3, ioa, true, state, qualifier, true);
			services[1] = new MPoll2AppSvc101(manager, null);
			services[2] = new MCommandAppSvc101(manager, (DbLocator) null,
					(byte) 45, 3, ioa, true, state, qualifier, false);
			index = 2;
		}

	}

	private int index = 0;
	private MAppService services[];

	@Override
	public int responseReceived(Response response) {
		System.out.println(index);
		System.out.println(select);
		if (select) {
			if (index == 2) {
				if (response.isAck()) {
					index = 1;
					return CONTINUE;
				} else
					return CONTINUE;
			} else if (response.isActivationConfirmation()) {
				index = 0;
				select = false;
				return CONTINUE;
			} else {
				index = 1;
				return CONTINUE;
			}

		} else if (index == 0) {
			if (response.isAck()) {
				index = 1;
				return CONTINUE;
			}
		} else {
			if (response.isActivationConfirmation()) {
				index = 1;
				return CONTINUE;
			} else if (response.isActivationTermination()) {
				index = 1;
				return SUCCESS;
			} else
				return CONTINUE;

		}
		return FAILED;
	}

	@Override
	public MAppService nextMessage() {
		if (services.length - 1 < index)
			return null;
		else
			return services[index];
	}

}
