/*
 * Class    br.org.scadabr.protocol.iec101.slave.SDataClass2AppSvc
 * File     SDataClass2AppSvc.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.AppService;
import br.org.scadabr.protocol.iec101.common.MapAsdu;
/**
 * <p>
 * This class defines an acknowledgement of general command service asdu.
 * <p>
 * Slave application has to answer such an asdu or a NACK one when receiving
 * a general command from master station.
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 19.II.03
 */
public class SDataClass2AppSvc extends AppService
{				
	/**
	 * <p>
	 * Instanciates a new asdu service to return on user data class 2
	 * requests.
	 */		
	public SDataClass2AppSvc(SAppManager manager, MapAsdu asdu)
	{
		super(
			asdu,
			// related link service
			new SRespondLnkSvc((SLnkManager)manager.lnk,SLnkService.DATA_CLASS_2),
			// no database notification
			null,
			// execution context
			manager.context
		);
	}	
}	// end SDataClass2AppSvc.java
