/*
 * Class	br.org.scadabr.protocol.iec101.slave.SLnkService
 * File		SLnkService.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.ControlField;
import br.org.scadabr.protocol.iec101.common.LnkService;

/**
 * <p>
 * This class defines service at link layer level for slave application.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class SLnkService extends LnkService
{
	/**
	 * Final static identifier for not used field.
	 */
	protected final static byte NOTUSED	= 0x7F;
	/**
	 *
	 */
	public final static byte END_OF_INIT	= 0x00;
	/**
	 * Data class 1 type
	 */
	public final static byte DATA_CLASS_1	= 0x01;
	/**
	 * Data class 2 type
	 */
	public final static byte DATA_CLASS_2	= 0x02;
	/**
	 * Type of service
	 */
	public byte type;
	/**
	 * Allocates a link service object.
	 *
	 * @param order			The link service to build.
	 * @param address		Remote/local address for a master/slave application.
	 * @param acd			Access demand bit as boolean
	 * @param dfc			Data flow control bit as boolean.
	 */
	public SLnkService(byte order, int address, boolean acd, boolean dfc)
	{
		super(new ControlField(false,order,acd,dfc),address);
		type = NOTUSED;
	}
}	// end SLnkService.java