/*
 * Class	br.org.scadabr.protocol.iec101.slave.SRespondLinkStatusLnkSvc
 * File		SRespondLinkStatusLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'respond link status or access demand' service at link layer level.
 * <p>
 * This service is used to answer master remote link status or acd request.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class SRespondLinkStatusLnkSvc extends SLnkService
{
	/**
	 * Allocates a link service object for responding link status or access demand status.
	 *
	 * @param manager	Link layer manager.
	 */
	public SRespondLinkStatusLnkSvc(SLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RESPOND_LINK_STATUS_OR_ACD,
			manager.address,
			manager.acd,
			manager.dfc
		);
	}	
}	// end SRespondLinkStatusLnkSvc.java

