/*
 * Class	br.org.scadabr.protocol.iec101.slave.SRespondLnkSvc
 * File		SRespondLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'respond user data' service at link layer level.
 * <p>
 * This service is used to answer master remote 1 & 2 data class polling
 * procedures.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class SRespondLnkSvc extends SLnkService
{
	/**
	 * Allocates a link service object for responding user data.
	 *
	 * @param manager	Link layer manager reference.
	 */
	public SRespondLnkSvc(SLnkManager manager, byte type)
	{	
		super(		
			Interoperability.SERVICE_S3_RESPOND_USER_DATA,
			manager.address,
			manager.acd,
			manager.dfc
		);
		this.type	= type;
	}
}	// end SRespondLnkSvc.java

