/*
 * Class    br.org.scadabr.protocol.iec101.slave.SRespondNackLnkSvc
 * File     SRespondNackLnkSvc.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'respond user data not available' service at link 
 * layer level.
 * <p>
 * This service is used to answer master remote1 & 2 data class polling
 * procedures when requested data no exists.
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class SRespondNackLnkSvc extends SLnkService
{
	/**
	 * Allocates a link service object for responding 'not available'
	 * on user data request from a master remote.
	 *
	 * @param manager	Link layer manager.
	 */	
	public SRespondNackLnkSvc(SLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_RESPOND_NACK,
			manager.address,
			manager.acd,
			manager.dfc
		);
	}	
}	// end SRespondNackLnkSvc.java
