/*
 * Class	br.org.scadabr.protocol.iec101.slave.SRespondNotFunctLnkSvc
 * File		SRespondNotFunctLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'respond link not functioning' service at link layer level.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class SRespondNotFunctLnkSvc extends SLnkService
{
	/**
	 * Allocates a link service object for responding link not functioning.
	 *
	 * @param manager	Link layer manager.
	 */
	public SRespondNotFunctLnkSvc(SLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_XX_LINK_NOT_FUNCTIONING,
			manager.address,
			manager.acd,
			manager.dfc
		);
	}
}	// end SRespondNotFunctLnkSvc.java

