/*
 * Class	br.org.scadabr.protocol.iec101.slave.SRespondNotImplLnkSvc
 * File		SRespondNotImplLnkSvc.java
 * Author	lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave;

import br.org.scadabr.protocol.iec101.common.Interoperability;

/**
 * <p>
 * This class defines 'respond link not implemented' service at link layer level.
 * 
 * @author	lionnel cauvy
 * @version	1.0
 * @date	28.II.03
 */
public class SRespondNotImplLnkSvc extends SLnkService
{
	/**
	 * Allocates a link service object for responding link not implemented.
	 *
	 * @param manager	Link layer manager.
	 */
	public SRespondNotImplLnkSvc(SLnkManager manager)
	{
		super(
			Interoperability.SERVICE_S3_XX_LINK_NOT_IMPLEMENTED,
			manager.address,
			manager.acd,
			manager.dfc
		);
	}
}	// end SRespondNotImplLnkSvc.java

