/*
 * Class    br.org.scadabr.protocol.iec101.slave101.SDelayAppSvc101
 * File     SDelayAppSvc101.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave101;

import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common101.AsduKey101;
import br.org.scadabr.protocol.iec101.common101.Interoperability101;
import br.org.scadabr.protocol.iec101.slave.SDataClass1AppSvc;

/**
 * <p>
 * This class defines a 'synchronization' application procedure for
 * master 101 application.
 * <p>
 * Here we set procedure identification, an asdu key to build a synchro
 * asdu, another asdu key as an expected answer from slave remote, the
 * related link service to implement,
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.IV.03
 */
public class SDelayAppSvc101 extends SDataClass1AppSvc
{	
	/**
	 * Instanciates a new triggered delay acquisiton asdu. Cause of transmission can be
	 * activation or spontaneous.
	 *
	 * @param manager	Application layer manager.
	 * @param notifier	Luciol database notifier.
	 * @param caa		Common address o asdu
	 * @param cot		Parametrable cause of transmission.
	 */		
	public SDelayAppSvc101(SAppManager101 manager, int caa, short cot)
	{
		super(
			manager,
			// asdu to build
			new MapAsdu(
				new AsduKey101(
					Interoperability101.ID_C_CD_NA_1,
					(short)1,
					Interoperability101.COT_ACTIVATIONCONF,
					(short)NOTUSED,
					caa
				)
			)			
		);
	}	
}	// end SDelayAppSvc101.java
