/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SAckComAppSvc103
 * File     SAckComAppSvc103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common103.AsduKey103;
import br.org.scadabr.protocol.iec101.common103.Interoperability103;
import br.org.scadabr.protocol.iec101.slave.SDataClass1AppSvc;
/**
 * <p>
 * This class defines an acknowledgement of general command service asdu.
 * <p>
 * Slave application has to answer such an asdu or a NACK one when receiving
 * a general command from master station.
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 19.II.03
 */
public class SAckComAppSvc103 extends SDataClass1AppSvc
{
	/**
	 * Double Point Information.
	 */
	public byte dpi;				
	/**
	 * <p>
	 * Instanciates a new asdu service to close general interrogation
	 * procedure.
	 *
	 * @param ack	Positive or negative acknoweldgement state.
	 * @param caa	Common address of asdu.
	 * @param ft	Function type.
	 * @param in	Information number.
	 * @param dpi	Double point information. 
	 */		
	public SAckComAppSvc103(SAppManager103 manager, boolean ack, int caa,short ft, short in, byte dpi)
	{
		super(
			manager,
			new MapAsdu(
				new AsduKey103(
					Interoperability103.ID_TIME_MSG,
					(short)129,
					(ack)?Interoperability103.COT_ACK_COM:Interoperability103.COT_NACK_COM,
					caa,
					ft,
					in
				)
			)
		);
		this.dpi = dpi;
	}	
}	// end SAckComAppSvc103.java
