/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SContext103
 * File     SContext103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

import br.org.scadabr.protocol.iec101.common.Context;
/**
 * <p>
 *
 * @author lionnel cauvy
 * @version 1.0
 * @date 01.II.03
 */
public class SContext103 extends Context
{
	public short ft;
	public int caa;
	public boolean clock;
	/**
	 * Start time of the application manager.
	 */
	public long start;
	/**
	 * <p>
	 * This 'Supplementary Information' field is used for time & 
	 * relative time messages. See SIN for further informations.
	 * <p>
	 * During general interrogation, SIN = SCN.
	 * <p>
	 * When receiving a general command, SIN = RII
	 * <p>
	 * Zero in other case.
	 */
	public short sin;
	/**
	 * <p>
	 * This 'Relative Time' field is used for relative time msgs.
	 * See RET for further informations.
	 * <p>
	 * Relative time is computed from effective start time of the
	 * related manager. (currentTimeMillis() - start).
	 */
	public int ret;
	/**
	 * <p>
	 * This 'Fault Number' field is used for relative time msgs.
	 * See FAN for further informations.
	 * <p>
	 * Fault number use ???????? = ZERO ;)
	 */
	public int fan;
	/**
	 * <p>
	 * This 'Compatibility Level' defines level of standard
	 * implementation.
	 */
	public final static short COL = 2;
	/**
	 * <p>
	 * This array of characters identifies this application
	 * as a 103 slave station. Array of 'ASC' elements.
	 */
	public byte[] asc;
	/**
	 * <p>
	 * Instanciate a new execution context for slave 103 application.
	 *
	 * @param address	Local station address.
	 * @param id		Local station identification string.
	 */
	public SContext103(int address, String id, short ft, int caa, boolean clock)
	{
		super(address,id);
		start = System.currentTimeMillis();
		ret = 0;
		fan = 0;
		sin = 0;
		asc = id.getBytes();
	}
}	// end SContext103.java
