/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SEndGeneralCdAppSvc103
 * File     SEndGeneralCdAppSvc103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common103.AsduKey103;
import br.org.scadabr.protocol.iec101.common103.Interoperability103;
import br.org.scadabr.protocol.iec101.slave.SDataClass1AppSvc;
/**
 * <p>
 * This class defines a 'general interrogation' mechanism for slave
 * 103 application.
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.II.03
 */
public class SEndGeneralCdAppSvc103 extends SDataClass1AppSvc
{			
	/**
	 * <p>
	 * Instanciates a new asdu service to close general interrogation
	 * procedure.
	 *
	 * @param manager	Application layer manager.
	 */		
	public SEndGeneralCdAppSvc103(SAppManager103 manager, int caa)
	{
		super(
			manager,
			new MapAsdu(
				new AsduKey103(
					Interoperability103.ID_END_GI,
					(short)129,
					Interoperability103.COT_END_GI,
					(short)caa,
					Interoperability103.FT_GLB,
					Interoperability103.IN_GI
				)
			)
		);
	}	
}	// end SEndGeneralCdAppSvc103.java
