/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SEndGiAppSvc103
 * File     SEndGiAppSvc103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common103.AsduKey103;
import br.org.scadabr.protocol.iec101.common103.Interoperability103;
import br.org.scadabr.protocol.iec101.slave.SDataClass1AppSvc;
/**
 * <p>
 * This class defines a 'general interrogation' mechanism.
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.II.03
 */
public class SEndGiAppSvc103 extends SDataClass1AppSvc
{			
	/**
	 * <p>
	 * Instanciates a new application procedure for indicating end
	 * of general interrogation to a remote master that have initiated
	 * it.
	 *
	 * @param manager	Application layer manager.
	 */		
	public SEndGiAppSvc103(SAppManager103 manager, int caa)
	{
		super(
			manager,
			// asdu to build
			new MapAsdu(
				new AsduKey103(
					Interoperability103.ID_END_GI,
					(short)129,
					Interoperability103.COT_END_GI,
					(short)caa,
					Interoperability103.FT_GLB,
					Interoperability103.IN_GI
				)
			)
		);
	}	
}	// end SEndGiAppSvc103.java
