/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SIdentificationAppSvc103
 * File     SIdentificationAppSvc103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

import br.org.scadabr.protocol.iec101.common.MapAsdu;
import br.org.scadabr.protocol.iec101.common103.AsduKey103;
import br.org.scadabr.protocol.iec101.common103.Interoperability103;
import br.org.scadabr.protocol.iec101.slave.SDataClass1AppSvc;

/**
 * <p>
 * This class defines a 'synchronization' application procedure for
 * slave 103 implementation.
 *
 * @author	lionnel cauvy
 * @version	1.0
 * @date 01.II.03
 */
public class SIdentificationAppSvc103 extends SDataClass1AppSvc
{			
	/**
	 * <p>
	 * Instanciates a new synchronization procedure. Asdu to generate
	 * in case of synchronization demand from a remote master.
	 *
	 * @param manager	Application layer manager.
	 */		
	public SIdentificationAppSvc103(SAppManager103 manager, short cot, int caa)
	{
		super(
			manager,
			// asdu to build
			new MapAsdu(
				new AsduKey103(
					Interoperability103.ID_SYNCHRO,
					(short)129,
					cot,
					(short)caa,
					Interoperability103.FT_GLB,
					Interoperability103.IN_SYNCHRO
				)
			)
		);
	}	
}	// end SIdentificationAppSvc103.java
