/*
 * Class    br.org.scadabr.protocol.iec101.slave103.SProcedure103
 * File     SProcedure103.java
 * Author   lionnel cauvy
 */
package br.org.scadabr.protocol.iec101.slave103;

/**
 * This interface defines type & priority in use for slave 103 implementation.
 */
public interface SProcedure103
{
	/**
	 * Identification asdu to return on reset cu procedure
	 */
	public final static byte S0_ID_CU		= 0x00;
	/**
	 * Identification asdu to return on reset fcb procedure
	 */
	public final static byte S0_ID_FCB		= 0x01;
	/**
	 * Start indication asdu.
	 */
	public final static byte S0_ID_START	= 0x02;
	/**
	 * Power on asdu.
	 */
	public final static byte S0_ID_POWER	= 0x03;
	/**
	 * USer data class 1 asdu
	 */
	public static final byte S1_CLASS1		= 0x04;
	/**
	 * User Data class 2 asdu.
	 */
	public static final byte S2_CLASS2		= 0x05;

	
	public static final int S0_PRIORITY		= 0;
	
	public static final int S1_PRIORITY		= 6;
	
	public static final int S2_PRIORITY		= 5;
	
	public static final int S6_PRIORITY		= 4;
	
	public static final int S3_PRIORITY		= 3;
	
	public static final int S4_PRIORITY		= 2;
	
	public static final int S8_PRIORITY		= 1;
	
}	// end SProcedure103.java