//
// The null input stream always returns -1.
// 
// Class     br.org.scadabr.io.NullInputStream.java
// File      NullInputStream.java
// Author    Alexis BIETTI <alexis.bietti@sysaware.com> 
// (c)       SysAware <http://www.sysaware.com/>
//
package br.org.scadabr.protocol.lib.xml;

import java.io.InputStream;

/**
 * The null input stream always returns -1.
 * 
 * @author <a href="mailto:alexis.bietti@sysaware.com">Alexis BIETTI</a>
 * @version 1.0 - 14 avr. 03
 */
public class NullInputStream extends InputStream {

  public int read() {
    return -1;
  }
  
  public void mark(int readlimit) {
  }

  public void reset() {
  }

  public boolean markSupported() {
    return true;
  }

  public int read(byte[] b, int off, int len) {
    return 0;
  }

  public int read(byte[] b) {
    return 0;
  }
  
  public int available() {
    return 0;
  }

  public long skip(long n) {
    return n;
  }
}

// End NullInputStream.java
