package com.i2msolucoes.alpha24j;

import com.i2msolucoes.alpha24j.util.ByteUtils;
import com.serotonin.util.queue.ByteQueue;

public class DeviceWrite {
	private DeviceLocator deviceLocator;
	private int deviceStatus;

	public enum DeviceStatus {
		ON((byte) 0x01), OFF((byte) 0x00);

		private final byte code;

		private DeviceStatus(byte code) {
			this.code = code;
		}

		public byte getCode() {
			return this.code;
		}
	}

	public DeviceWrite(DeviceLocator device, int deviceStatus) {
		this.deviceLocator = device;
		this.deviceStatus = deviceStatus;
	}

	public byte[] getBytes() {
		ByteQueue queue = new ByteQueue();
		queue.push(deviceLocator.getBytes());

		if (isWordDevice())
			queue.push(ByteUtils.intTo2Bytes(deviceStatus));
		else
			queue.push(deviceStatus);

		return queue.popAll();
	}

	private boolean isWordDevice() {
		return (deviceLocator.isWordDevice());
	}

}
