package com.i2msolucoes.alpha24j.frame.request;

import java.util.List;

import com.i2msolucoes.alpha24j.DeviceLocator;
import com.i2msolucoes.alpha24j.element.Elements;
import com.i2msolucoes.alpha24j.element.Elements.ControlCodes;
import com.serotonin.util.queue.ByteQueue;

public class ReadCommand extends FormatBMessage {

	private List<DeviceLocator> devices;

	public ReadCommand(byte station, List<DeviceLocator> devices) {
		super(station);
		this.devices = devices;
	}

	@Override
	protected byte getNoCommBytes() {
		return (byte) ((devices.size() * 3) + 4);
	}

	@Override
	protected byte[] getDataBytes() {
		ByteQueue data = new ByteQueue();
		data.push(Elements.CommandCodes.READ.getCode());
		data.push(devices.size());

		for (DeviceLocator device : devices) {
			data.push(device.getBytes());
		}

		data.push(ControlCodes.ETX.getCode());
		return data.popAll();
	}

	@Override
	public boolean isReadCommandMessage() {
		return true;
	}

	public List<DeviceLocator> getDevices() {
		return devices;
	}

}
