package com.i2msolucoes.alpha24j.frame.request;

import com.i2msolucoes.alpha24j.element.Elements;
import com.i2msolucoes.alpha24j.element.Elements.ControlCodes;
import com.serotonin.util.queue.ByteQueue;

public class RunStopCommand extends FormatBMessage {

	private RunStopCodes command;

	public enum RunStopCodes {
		RUN((byte) 0x01), STOP((byte) 0x00);

		private final byte code;

		private RunStopCodes(byte code) {
			this.code = code;
		}

		public byte getCode() {
			return this.code;
		}
	}

	public RunStopCommand(byte station, RunStopCodes command) {
		super(station);
		this.command = command;
	}

	@Override
	protected byte getNoCommBytes() {
		return 4;
	}

	@Override
	protected byte[] getDataBytes() {
		ByteQueue data = new ByteQueue();
		data.push(Elements.CommandCodes.RUN_STOP.getCode());
		data.push(command.getCode());
		data.push(ControlCodes.ETX.getCode());
		return data.popAll();
	}

	@Override
	public boolean isWriteCommandMessage() {
		return true;
	}

}
