package com.i2msolucoes.alpha24j.frame.request;

import java.util.List;

import com.i2msolucoes.alpha24j.DeviceWrite;
import com.i2msolucoes.alpha24j.element.Elements;
import com.i2msolucoes.alpha24j.element.Elements.ControlCodes;
import com.serotonin.util.queue.ByteQueue;

public class WriteCommand extends FormatBMessage {

	private List<DeviceWrite> devices;

	public WriteCommand(byte station, List<DeviceWrite> devices) {
		super(station);
		this.devices = devices;
	}

	@Override
	protected byte getNoCommBytes() {
		int total = 0;
		for (DeviceWrite device : devices) {
			total = total + device.getBytes().length;
		}
		return (byte) (total + 4);
	}

	@Override
	protected byte[] getDataBytes() {
		ByteQueue data = new ByteQueue();

		data.push(Elements.CommandCodes.WRITE.getCode());
		data.push(devices.size());

		for (DeviceWrite device : devices) {
			data.push(device.getBytes());
		}

		data.push(ControlCodes.ETX.getCode());
		return data.popAll();
	}

	@Override
	public boolean isWriteCommandMessage() {
		return true;
	}

}
