package com.i2msolucoes.alpha24j.frame.response;

import com.i2msolucoes.alpha24j.element.Elements.ControlCodes;
import com.i2msolucoes.alpha24j.element.Elements.ErrorCodes;
import com.i2msolucoes.alpha24j.frame.request.Alpha2RequestFrame;
import com.serotonin.util.queue.ByteQueue;

public class ErrorResponseFrame extends Alpha2ResponseFrame {

	private ErrorCodes errorCode;

	public ErrorResponseFrame(Alpha2RequestFrame sent, ByteQueue received)
			throws Exception {
		super(sent, received);
	}

	public ErrorResponseFrame(Alpha2RequestFrame sent, ByteQueue received,
			ErrorCodes code) throws Exception {
		super(sent, received);
		this.errorCode = code;
	}

	@Override
	protected void checkAndBuildResponse() throws Exception {
		ensureTrue(received.size() == 6);
		ensureTrue(received.peek(4) == ControlCodes.NACK.getCode());
		ensureTrue(ErrorCodes.isValidErrorCode(received.peek(5)));

		errorCode = ErrorCodes.toErrorCode(received.peek(5));
	}

	public ErrorCodes getErrorCode() {
		return errorCode;
	}

	@Override
	public boolean isErrorMessage() {
		return true;
	}

}
