package com.i2msolucoes.alpha24j.test;

import java.util.ArrayList;
import java.util.List;

import com.i2msolucoes.alpha24j.DeviceLocator;
import com.i2msolucoes.alpha24j.DeviceLocator.DeviceCodes;
import com.i2msolucoes.alpha24j.DeviceWrite;
import com.i2msolucoes.alpha24j.frame.request.Alpha2RequestFrame;
import com.i2msolucoes.alpha24j.frame.request.LineCheckCommand;
import com.i2msolucoes.alpha24j.frame.request.ReadCommand;
import com.i2msolucoes.alpha24j.frame.request.RunStopCommand;
import com.i2msolucoes.alpha24j.frame.request.RunStopCommand.RunStopCodes;
import com.i2msolucoes.alpha24j.frame.request.WriteCommand;
import com.i2msolucoes.alpha24j.util.ByteUtils;

public class GeneralTest {
	public static void main(String[] args) {
		Alpha2RequestFrame lineCheck = new LineCheckCommand((byte) 0x00);

		ByteUtils.displayBytes("Line Check", lineCheck.getFrame());

		List<DeviceLocator> devices = new ArrayList<DeviceLocator>();
		devices.add(new DeviceLocator(DeviceCodes.COMM_WORD_DEVICE, 05));
		devices.add(new DeviceLocator(DeviceCodes.COMM_WORD_DEVICE, 06));

		Alpha2RequestFrame readCommand = new ReadCommand((byte) 0x00, devices);

		ByteUtils.displayBytes("Read Command", readCommand.getFrame());

		List<DeviceWrite> devicesToWrite = new ArrayList<DeviceWrite>();
		devicesToWrite.add(new DeviceWrite(new DeviceLocator(
				DeviceCodes.EXTERNAL_OUTPUT, 1), 1));

		Alpha2RequestFrame writeCommand = new WriteCommand((byte) 0x00,
				devicesToWrite);
		ByteUtils.displayBytes("Write Command", writeCommand.getFrame());

		Alpha2RequestFrame runStopCommand = new RunStopCommand((byte) 0x00,
				RunStopCodes.RUN);
		ByteUtils.displayBytes("Run/Stop Command", runStopCommand.getFrame());

	}
}
