package com.i2msolucoes.alpha24j.test;

import gnu.io.SerialPort;

import java.io.IOException;

import com.i2msolucoes.alpha24j.exception.COMMException;
import com.i2msolucoes.alpha24j.layer.physical.PhysicalLayer;
import com.i2msolucoes.alpha24j.layer.physical.serial.SerialPhysicalLayer;
import com.i2msolucoes.alpha24j.util.ByteUtils;
import com.serotonin.io.serial.SerialParameters;

public class PhyLayerTest {

	/**
	 * @param args
	 * @throws COMMException
	 * @throws InterruptedException
	 */
	public static void main(String[] args) throws IOException, COMMException {
		SerialParameters parameters = new SerialParameters();
		parameters.setBaudRate(9600);
		parameters.setCommPortId("COM1");
		parameters.setParity(SerialPort.PARITY_NONE);
		parameters.setStopBits(SerialPort.STOPBITS_1);
		parameters.setDataBits(SerialPort.DATABITS_8);

		PhysicalLayer phy = new SerialPhysicalLayer(parameters, 10000, 1);
		phy.init();

		byte[] received = phy
				.sendAndReceive(HardCodedFrames.READ_FRAME_WITH_CRC_ERROR);

		// for (int i = 0; i < received.length; i++) {
		// System.out.print(received[i] + " ");
		// }

		ByteUtils.displayBytes(received);
		phy.close();

	}

}
