package com.i2msolucoes.alpha24j.util;

import com.serotonin.util.queue.ByteQueue;

public class ByteUtils {

	public static void displayBytes(String frameName, byte[] bytes) {
		System.out.print(frameName + ": ");
		displayBytes(bytes);
	}

	public static void displayBytes(byte[] bytes) {
		StringBuilder s = new StringBuilder();
		for (int i = 0; i < bytes.length; i++) {
			int parteAlta = ((bytes[i] >> 4) & 0xf) << 4;
			int parteBaixa = bytes[i] & 0xf;

			String x = Integer.toHexString(parteAlta | parteBaixa);
			if (x.length() == 1)
				x = "0" + x;
			s.append("[" + "0x" + x.toUpperCase() + "] ");
		}
		System.out.println(s.toString());
	}

	public static byte[] intTo2Bytes(int number) {
		byte lowByte = (byte) (byte) (number);
		byte highByte = (byte) ((number >> 8));

		return new byte[] { lowByte, highByte };
	}

	public static byte[] calculateCRC(ByteQueue queue) {

		int crc = 0;

		for (int i = 2; i < queue.size() - 1; i++) {
			crc = crc + queue.peek(i);
		}

		return intTo2Bytes(crc);
	}

	public static byte[] toBytes(int value, int size) {
		byte[] result = new byte[size];

		for (int i = 0; i < result.length; i++) {
			result[i] = (byte) ((value >> (8 * i)) & 0xFF);
		}
		return result;
	}

	public static final int bytesToInt(byte[] b) {
		int i = 0;
		i |= b[1] & 0xFF;
		i <<= 8;
		i |= b[0] & 0xFF;
		return i;
	}

}
