package com.i2msolucoes.alpha24j.util;

import java.util.List;

import com.i2msolucoes.alpha24j.DeviceValue;
import com.i2msolucoes.alpha24j.frame.response.Alpha2ResponseFrame;
import com.i2msolucoes.alpha24j.frame.response.ErrorResponseFrame;
import com.i2msolucoes.alpha24j.frame.response.LineCheckResponseFrame;
import com.i2msolucoes.alpha24j.frame.response.ReadResponseFrame;

public class PrintUtils {

	public static void printDeviceValues(List<DeviceValue> values) {
		for (DeviceValue deviceValue : values) {
			System.out.println("Device Code: "
					+ deviceValue.getLocator().getCode() + " / Value: "
					+ deviceValue.getValue());
		}
	}

	public static void printResponseReceived(Alpha2ResponseFrame response) {
		if (response.isInvalidFrame()) {
			System.out.println("INVALID FRAME");
		} else if (response.isErrorMessage()) {
			System.out.println("ERROR FRAME");
			System.out.println("Error code: "
					+ ((ErrorResponseFrame) response).getErrorCode());
			System.out.println(((ErrorResponseFrame) response).getErrorCode()
					.getDescription());

		} else if (response.isReadResponseMessage()) {
			System.out.println("READ RESPONSE FRAME");
			printDeviceValues(((ReadResponseFrame) response).getValues());

		} else if (response.isWriteResponseMessage()) {
			System.out.println("WRITE RESPONSE");
			System.out.println("WriteCommand: OK! ");
		} else if (response.isLineCheckResponseMessage()) {
			System.out.println("LINE CHECK RESPONSE");
			boolean lineStatus = ((LineCheckResponseFrame) response).isLineOK();
			if (lineStatus) {
				System.out.println("Line Status: OK! ");
			} else {
				System.out.println("Line Status: BAD! ");
				System.out.println("Error: "
						+ ((LineCheckResponseFrame) response).getErrorCode());
			}

		}
	}
}
