package br.org.scadabr.protocol.util;

public class Double {
	public static final double POSITIVE_INFINITY = (1.0D / 0.0D);
	public static final double NEGATIVE_INFINITY = (-1.0D / 0.0D);
	public static final double NaN = (0.0D / 0.0D);
	public static final double MAX_VALUE = 1.7976931348623157E+308D;
	public static final double MIN_VALUE = longBitsToDouble(1L);
	private double val;

	public Double(double paramDouble) {
		this.val = paramDouble;
	}

	public static boolean isNaN(double paramDouble) {
		return (paramDouble != paramDouble);
	}

	public boolean isNaN() {
		return (this.val != this.val);
	}

	public static boolean isInfinite(double paramDouble) {
		return ((paramDouble == (1.0D / 0.0D)) || (paramDouble == (-1.0D / 0.0D)));
	}

	public boolean isInfinite() {
		return ((this.val == (1.0D / 0.0D)) || (this.val == (-1.0D / 0.0D)));
	}

	public byte byteValue() {
		return (byte) (int) this.val;
	}

	public short shortValue() {
		return (short) (int) this.val;
	}

	public int intValue() {
		return (int) this.val;
	}

	public long longValue() {
		return (long) this.val;
	}

	public float floatValue() {
		return (float) this.val;
	}

	public double doubleValue() {
		return this.val;
	}

	public int hashCode() {
		long l = doubleToLongBits(this.val);
		return (int) (l ^ l >> 32);
	}

	public boolean equals(Object paramObject) {
		if ((paramObject != null) && (paramObject instanceof Double))
			return (doubleToLongBits(((Double) paramObject).val) == doubleToLongBits(this.val));
		return false;
	}

	public static native long doubleToLongBits(double paramDouble);

	public static native double longBitsToDouble(long paramLong);
}

