 
package br.org.scadabr.protocol.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.Queue;

public class FifoQueue implements Queue {

	private int maxElementCount;
	private int head = 0;
	private int tail = 0;
	private int elementCount = 0;
	private Object[] elementData;

	public FifoQueue(int paramInt) {
		this.maxElementCount = paramInt;
		this.elementData = new Object[paramInt];
	}

	public int getElementCount() {
		return this.elementCount;
	}

	public boolean isEmpty() {
		return (this.elementCount == 0);
	}

	public boolean isFull() {
		return (this.elementCount >= this.maxElementCount - 1);
	}

	public synchronized int enqueue(Object paramObject) {
		if (this.elementCount >= this.maxElementCount)
			return -1;
		this.elementData[this.tail] = paramObject;
		this.tail = ((this.tail + 1) % this.maxElementCount);
		this.elementCount += 1;
		super.notify();
		return (this.maxElementCount - this.elementCount);
	}

	public synchronized Object dequeue() {
		if (this.elementCount <= 0)
			return null;
		Object localObject = this.elementData[this.head];
		this.head = ((this.head + 1) % this.maxElementCount);
		this.elementCount -= 1;
		return localObject;
	}

	public synchronized Object blockingDequeue() {
		return blockingDequeue(0);
	}

	public synchronized Object blockingDequeue(int paramInt) {
		while (this.elementCount <= 0) {
			try {
				super.wait(paramInt);
			} catch (InterruptedException localInterruptedException) {
			}
			if ((paramInt > 0) && (this.elementCount <= 0))
				return null;
		}
		Object localObject = this.elementData[this.head];
		this.head = ((this.head + 1) % this.maxElementCount);
		this.elementCount -= 1;
		return localObject;
	}

	@Override
	public boolean add(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public Object element() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean offer(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public Object peek() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object poll() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object remove() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean addAll(Collection arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void clear() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean contains(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean containsAll(Collection arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public Iterator iterator() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean remove(Object arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean removeAll(Collection arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean retainAll(Collection arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public int size() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public Object[] toArray() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object[] toArray(Object[] arg0) {
		// TODO Auto-generated method stub
		return null;
	}
}
